/*
 *   ʐ䕔..
 *
 */
#include <QCoreApplication>
#include <QtGlobal>
#include <QMessageBox>
#include <QFileDialog>
#include <QFile>
#include <QDate>
#include <QTextStream>
#include "aplVersion.h"
#include "mainProcedures.h"

/*
 *  RXgN^ (ʕ\)
 *
 */
mainProcedures::mainProcedures(Ui::mainForm *uiForm, QWidget *parent) : QWidget(parent)
{
    // tH[L^
    ui = uiForm;

    // \bh
    prepare();
}

/*
 *  fXgN^ (ʕ\̂Ƃ܂)
 *
 */
mainProcedures::~mainProcedures()
{
    delete mpHttpConn2;
    delete mpHttpConn1;
    delete mpHttpConn0;
}

/*
 *  NX̏...
 *
 */
void mainProcedures::prepare(void)
{
    mpHttpConn0 = new a2BChttpConnection(&mHttpIndex0);
    mpHttpConn1 = new a2BChttpConnection(&mHttpIndex1);
    mpHttpConn2 = new a2BChttpConnection(&mHttpIndex2);

    connect(mpHttpConn0, SIGNAL(completedCommunication(int, QString &)),
            this,        SLOT(completedCommunication(int, QString &)));

    connect(mpHttpConn1, SIGNAL(completedCommunication(int, QString &)),
            this,        SLOT(completedCommunication(int, QString &)));

    connect(mpHttpConn2, SIGNAL(completedCommunication(int, QString &)),
            this,        SLOT(completedCommunication(int, QString &)));


    return;
}

/*
 *  Qt̏\
 *
 */
void mainProcedures::show_aboutQt(bool checked)
{
    // Qt̃o[W\
    QMessageBox::aboutQt(this);
    return;
}

/*
 *  o[W̕\
 *
 */
void mainProcedures::show_version(bool checked)
{
    QString caption = "about " + APL_NAME;
    QString message = APL_CREDIT + "\n" + APL_VERSION + " (" + APL_DATE + ")\n\n" + APL_COMMENT;

    QMessageBox::information(this, caption, message, QMessageBox::Ok);
    return;
}

/*
 *  AvP[ṼX^[gI
 *
 */
void mainProcedures::startup(void)
{
    return;
}

/*
 *  AvP[V̊JnI
 *
 */
void mainProcedures::startApp(void)
{
    // f[^t@C̓ǂݏo...
    QString dataFileName = QCoreApplication::applicationDirPath() + "/qTVg.dat";
    if (QFile::exists(dataFileName) == false)
    {
        // f[^t@CȂ...I
        return;
    }
    QFile dataFile(dataFileName);
    if (!dataFile.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        // f[^t@CI[vɎsAAAI
        return;
    }

    // f[^t@CPsÂǂݏo
    int count = 0;
    QTextStream in(&dataFile);
    while (!in.atEnd())
    {
        QString line = in.readLine();
        extractData(count, line);
        count++;
    }
    dataFile.close();

    // f[^ʂɔfI
    updateLogInformation();
    return;
}

/*
 *  f[^ǂݏoēWJ
 */
void mainProcedures::extractData(int lineData, QString &arLineData)
{
    if (arLineData.isEmpty() == true)
    {
        // f[^Ȃ...I
    }

    int     index = 0;
    QString dataString = arLineData.section(";", 0, 0);
    switch (lineData)
    {
      case 0:
        // f[^L^fBNg
        (ui->fldDataDirectory)->setText(dataString);
        break;

      case 1:
        // n
        index = (ui->cmbAreaId)->findData(QVariant(dataString.toInt()));
        if (index >= 0)
        {
            (ui->cmbAreaId)->setCurrentIndex(index);
        }
        break;

      default:
        // Ȃ
        break;
    }
    //    QMessageBox::information(0, "", dataFile);
    return;
}

/*
 *  AvP[V̏II
 *
 */
void mainProcedures::finishApp(void)
{
    // f[^t@C̏o...
    QString dataFileName = QCoreApplication::applicationDirPath() + "/qTVg.dat";

    // Ât@CꍇA폜
    if (QFile::exists(dataFileName) == true)
    {
        QFile::remove(dataFileName);
    }

    // opɃI[v
    QFile dataFile(dataFileName);
    if (!dataFile.open(QIODevice::WriteOnly | QIODevice::Text))
    {
        return;
    }

    QTextStream out(&dataFile);
    out << (ui->fldDataDirectory)->text() << ";" << endl;

    int index = (ui->cmbAreaId)->currentIndex();
    int areaId = ((ui->cmbAreaId)->itemData(index)).toInt();
    out << areaId << ";" << endl;

    out.flush();
    dataFile.close();

    return;
}

/*
 *  ufBNgݒv{^Ƃ...
 *
 */
void mainProcedures::selectDirectory()
{
    QString fileName = (ui->fldDataDirectory)->text();
    fileName = QFileDialog::getExistingDirectory(0, tr("Directory Selection"), fileName);
    if (fileName.isEmpty() != true)
    {
        (ui->fldDataDirectory)->setText(fileName);
    }
    return;
}

/*
 *  uf[^擾v{^Ƃ...
 *
 */
void mainProcedures::getDataFile()
{
    if (QMessageBox::question(0, tr("HTTP COMM."), tr("Data Get, Ready?"), 
        (QMessageBox::Ok | QMessageBox::Cancel)) != QMessageBox::Ok)
    {
        // LZꂽ...擾ȂBiIj
        return;
    }

    // nID擾
    int index = (ui->cmbAreaId)->currentIndex();
    int areaId = ((ui->cmbAreaId)->itemData(index)).toInt();

    // t@Cwb_쐬
    QString cookie;
    cookie.setNum(areaId);
    cookie = "areaId=" + cookie + "; span=24";
    QDate currentDate = (ui->calendarWidget)->selectedDate();
    QString dateString;
    dateString.setNum(areaId);
    dateString = currentDate.toString("yyyyMMdd") + "-" + dateString + "-";
    dateString = (ui->fldDataDirectory)->text() + "/" + dateString;
    QString urlHeader = "http://tv.so-net.ne.jp/guest/pc/chart.action?&span=24&head=" + currentDate.toString("yyyyMMdd") + "0500" + "&index=";

    if ((ui->checkBox_0)->isChecked() == true)
    {
        // ng̃f[^t@C擾
        QString dataFileName = dateString + "0.html";
        QString urlToGet = urlHeader + "0";
        mpHttpConn0->setCookie(cookie);
        mpHttpConn0->getFileFromUrl(dataFileName, urlToGet, false);
    }

    if ((ui->checkBox_1)->isChecked() == true)
    {
        // UHF/BS̃f[^t@C擾
        QString dataFileName = dateString + "1.html";
        QString urlToGet = urlHeader + "1";
        mpHttpConn1->setCookie(cookie);
        mpHttpConn1->getFileFromUrl(dataFileName, urlToGet, false);
    }

    if ((ui->checkBox_2)->isChecked() == true)
    {
        // BSfW^̃f[^t@C폜
        QString dataFileName = dateString + "2.html";
        QString urlToGet = urlHeader + "2";
        mpHttpConn2->setCookie(cookie);
        mpHttpConn2->getFileFromUrl(dataFileName, urlToGet, false);
    }

    // XV
    updateLogInformation();
}

/*
 *  uf[^폜v{^Ƃ...
 *
 */
void mainProcedures::deleteDataFile()
{
    if (QMessageBox::question(0, tr("delete File"), tr("File Delete, OK?"), 
        (QMessageBox::Ok | QMessageBox::Cancel)) != QMessageBox::Ok)
    {
        // LZꂽ...폜ȂBiIj
        return;
    }

    // nID擾
    int index = (ui->cmbAreaId)->currentIndex();
    int areaId = ((ui->cmbAreaId)->itemData(index)).toInt();

    // t@Cwb_쐬
    QDate currentDate = (ui->calendarWidget)->selectedDate();
    QString dateString;
    dateString.setNum(areaId);
    dateString = currentDate.toString("yyyyMMdd") + "-" + dateString + "-";
    dateString = (ui->fldDataDirectory)->text() + "/" + dateString;

    if ((ui->checkBox_0)->isChecked() == true)
    {
        // ng̃f[^t@C폜
        QString dataFileName = dateString + "0.html";
        if (QFile::exists(dataFileName) == true)
        {
            QFile::remove(dataFileName);
        }
    }

    if ((ui->checkBox_1)->isChecked() == true)
    {
        // UHF/BS̃f[^t@C폜
        QString dataFileName = dateString + "1.html";
        if (QFile::exists(dataFileName) == true)
        {
            QFile::remove(dataFileName);
        }
    }

    if ((ui->checkBox_2)->isChecked() == true)
    {
        // BSfW^̃f[^t@C폜
        QString dataFileName = dateString + "2.html";
        if (QFile::exists(dataFileName) == true)
        {
            QFile::remove(dataFileName);
        }
    }

    // XV
    updateLogInformation();
}

/*
 *  uv{^Ƃ̏...
 *
 */
void mainProcedures::moveToToday()
{
    (ui->calendarWidget)->setSelectedDate(QDate::currentDate());
    updateLogInformation();
}

/*
 *  ʏXV
 *
 */
void mainProcedures::updateLogInformation()
{
    QDate currentDate = (ui->calendarWidget)->selectedDate();
    QString dateString = currentDate.toString("yyyy/MM/dd");
    (ui->lblDate)->setText(dateString);

    // nID擾
    int index = (ui->cmbAreaId)->currentIndex();
    int areaId = ((ui->cmbAreaId)->itemData(index)).toInt();

    // ng̃t@C邩ǂH
    dateString.setNum(areaId);
    dateString = currentDate.toString("yyyyMMdd") + "-" + dateString + "-" + "0.html";
    bool isIndex0 = QFile::exists((ui->fldDataDirectory)->text() + "/" + dateString);
    if (isIndex0 == true)
    {
        (ui->dataIndex_0)->setText(tr("Exist"));
    }
    else
    {
        (ui->dataIndex_0)->setText(tr("None"));
    }

    // UHF/BS̃t@C邩H
    dateString.setNum(areaId);
    dateString = currentDate.toString("yyyyMMdd") + "-" + dateString + "-" + "1.html";
    bool isIndex1 = QFile::exists((ui->fldDataDirectory)->text() + "/" + dateString);
    if (isIndex1 == true)
    {
        (ui->dataIndex_1)->setText(tr("Exist"));
    }
    else
    {
        (ui->dataIndex_1)->setText(tr("None"));
    }

    // BSfW^̃t@C邩H
    dateString.setNum(areaId);
    dateString = currentDate.toString("yyyyMMdd") + "-" + dateString + "-" + "2.html";
    bool isIndex2 = QFile::exists((ui->fldDataDirectory)->text() + "/" + dateString);
    if (isIndex2 == true)
    {
        (ui->dataIndex_2)->setText(tr("Exist"));
    }
    else
    {
        (ui->dataIndex_2)->setText(tr("None"));
    }

    // 
    bool enableGetButton = true;
    if (mpHttpConn0 != 0)
    {
       if (mpHttpConn0->isCommunicating() == true)
       {
           enableGetButton = false;
       }
    }
    if (mpHttpConn1 != 0)
    {
       if (mpHttpConn1->isCommunicating() == true)
       {
           enableGetButton = false;
       }
    }
    if (mpHttpConn2 != 0)
    {
       if (mpHttpConn2->isCommunicating() == true)
       {
           enableGetButton = false;
       }
    }

    // O擾{^𐧌䂷
    (ui->btnGet)->setEnabled(enableGetButton);
    (ui->btnClear)->setEnabled(enableGetButton);
}

/**
 *  ʐMIMBBB
 *
 */
void mainProcedures::completedCommunication(int id, QString &arMsg)
{
    updateLogInformation();
}
/*
 *  qTVg
 *  Copyright (C) 2007- NNsi Project
 *  (see qTVg-src.txt for detail.)
 */
